var call_module = weex.requireModule('tsl-call');

var imcall = {
    onCallStatusListener: function (callBack) {
        call_module.onCallStatusListener(callBack)
    },
    makeCall: function (OBJECT) {
        call_module.makeCall(OBJECT, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    makeOnlyCall: function (OBJECT) {
        call_module.makeOnlyCall({
            remoteId: OBJECT.remoteId,
            callTips: OBJECT.callTips,
            callType: OBJECT.callType,
            roomId: OBJECT.roomId,
            url: OBJECT.url,
            option: OBJECT.option
        }, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    newCall: function (OBJECT) {
        call_module.newCall(OBJECT, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    startPlaySoundEffect: function () {
        call_module.startPlaySoundEffect()
    },
    stopPlaySoundEffect: function () {
        call_module.stopPlaySoundEffect()
    },
    acceptCall: function () {
        call_module.acceptCall()
    },
    endCall: function () {
        call_module.endCall()
    },
    cancelCall: function () {
        call_module.cancelCall()
    },
    rejectCall: function () {
        call_module.rejectCall()
    },
    turnOnOrOffCamera: function (bool) {
        call_module.turnOnOrOffCamera(bool)
    },
    toggleMic: function (bool) {
        call_module.toggleMic(bool)
    },
    switchCamera: function (bool) {
        call_module.switchCamera(bool)
    },
    switchSpeaker: function (bool) {
        call_module.switchSpeaker(bool)
    },
    setBeauty: function (value) {
        call_module.setBeauty(value)
    },
    inviteUser: function (ids) {
        call_module.inviteUser(ids)
    },
    YMZCall: function (OBJECT) {
        call_module.YMZCall(OBJECT, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    showInFloatWindowMode: function (OBJECT) {
        call_module.showInFloatWindowMode(OBJECT)
    },
    changeVideoToSound: function () {
        call_module.changeVideoToSound()
    },
    changeSoundToVideo: function () {
        call_module.changeSoundToVideo()
    },
    wateInRoom: function () {
        call_module.wateInRoom()
    },
    startRecordVideo:function(OBJECT){
        try {
            call_module.startRecordVideo(OBJECT,OBJECT.success, OBJECT.fail, OBJECT.complete)
        } catch (error) {
            let result={
                'errMsg':'startRecordVideo:fail no such method'
            }
            if(OBJECT.fail){
                OBJECT.fail(result)
            }
            if(OBJECT.complete){
                OBJECT.complete(result)
            }
        }
    },
    stopRecordVideo:function(OBJECT){
        try {
            call_module.stopRecordVideo(OBJECT.success, OBJECT.fail, OBJECT.complete)
        } catch (error) {
            let result={
                'errMsg':'stopRecordVideo:fail no such method'
            }
            if(OBJECT.fail){
                OBJECT.fail(result)
            }
            if(OBJECT.complete){
                OBJECT.complete(result)
            }
        }
    },
    setILiveSDKChannelModeSync:function(channelMode){
        try {
           return call_module.setILiveSDKChannelModeSync(channelMode)
        } catch (error) {
            return false;
        }
    }

}
export default imcall