
var location_module = weex.requireModule('tsl-location');
var location = {
    getLocation: function (OBJECT) {
        location_module.getLocation(OBJECT, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    startLocation: function (OBJECT) {
        location_module.startLocation(OBJECT)
    },
    stopLocation: function () {
        location_module.stopLocation()
    },
    chooseLocation: function (OBJECT) {
        location_module.chooseLocation({}, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    openLocation: function (OBJECT) {
        location_module.openLocation({
            latitude: OBJECT.latitude,
            longitude: OBJECT.longitude,
            scale: OBJECT.scale,
            name: OBJECT.name,
            address: OBJECT.address
        })
    },
    distanceSearch: function (OBJECT) {
        location_module.distanceSearch( OBJECT , OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    routeSearch: function (OBJECT) {
        location_module.routeSearch( OBJECT , OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    //将路径获取的数据转换为marker点和polyline线
    resultToRoute: function (e) {
        var line = [];
        var mark = [];
        if (e.type == 'walk' || e.type == 'ride' || e.type == 'drive') {
            for (let index = 0; index < e.paths[0].steps.length; index++) {
                const element = e.paths[0].steps[index];
                var poly = {
                    id: index,
                    points: element.polyline,
                    color: "#CC6666FF",
                    width: 12,
                }
                line.push(poly);
                var mak = {
                    iconPath: e.type,
                    id: index,
                    title: element.action,
                    snippet: element.instruction,
                    latitude: element.polyline[0].latitude,
                    longitude: element.polyline[0].longitude,
                    width: 50,
                    height: 50,
                    anchor: { x: 0.5, y: 0.5 },
                }
                mark.push(mak);
            }
        } else {
            for (let index = 0; index < e.paths[0].steps.length; index++) {

                const element = e.paths[0].steps[index];

                if (element.type == 'walk') {

                    for (let index1 = 0; index1 < element.steps.length; index1++) {

                        const element1 = element.steps[index1];

                        var poly = {
                            id: index + "-" + index1,
                            points: element1.polyline,
                            color: "#DD66AA66",
                            width: 12,
                            dottedLine: element.type == 'walk'
                        }
                        line.push(poly);

                        var mak = {
                            iconPath: element.type,
                            id: index + "-" + index1,
                            title: element1.action,
                            snippet: element1.instruction,
                            latitude: element1.polyline[0].latitude,
                            longitude: element1.polyline[0].longitude,
                            width: 50,
                            height: 50,
                            anchor: { x: 0.5, y: 0.5 },
                        }
                        mark.push(mak);

                    }

                }

                if (element.type == 'bus') {

                    for (let index1 = 0; index1 < element.busLines.length; index1++) {

                        const element1 = element.busLines[index1];

                        var poly = {
                            id: index + "-" + index1,
                            points: element1.polyline,
                            color: "#CC6666FF",
                            width: 20,
                            dottedLine: element.type == 'walk'
                        }
                        line.push(poly);

                        // modal.alert({ message: JSON.stringify(element1)})

                        var mak = {
                            iconPath: element.type,
                            id: index + "-" + index1,
                            title: "从" + element1.departureBusStation.busStationName + "站上车-到" + element1.arrivalBusStation.busStationName + "站下车",
                            // snippet: element1.instruction,
                            latitude: element1.polyline[0].latitude,
                            longitude: element1.polyline[0].longitude,
                            width: 50,
                            height: 50,
                            anchor: { x: 0.5, y: 0.5 },
                        }
                        mark.push(mak);
                    }
                }

            }

        }
        mark.push({
            iconPath: 'start',
            id: -1,
            title: "起点",
            snippet: "出发",
            latitude: 23.099994,
            longitude: 113.324520,
        })
        mark.push({
            iconPath: 'end',
            id: -2,
            title: "终点",
            snippet: "到达",
            latitude: 23.21229,
            longitude: 113.324520,
        })
        return {markers:mark,polyline:line}
    }
};
export default  location;