
var tslPlayer = weex.requireModule("tsl-player");
var player = {
    playVoice: function (OBJECT) {
        tslPlayer.playVoice({ filePath: OBJECT.filePath }, OBJECT.success, OBJECT.fail, OBJECT.complete);
    },
    pauseVoice: function () {
        tslPlayer.pauseVoice();
    },
    stopVoice: function () {
        tslPlayer.stopVoice();
    },
    onVoicePlayEnd: function (OBJECT) {
        tslPlayer.onVoicePlayEnd(OBJECT.playEnd);
    },
    createInnerAudioContext: function () {
        var tslAudioContext = {}
        tslAudioContext['src'] = ""
        tslAudioContext['startTime'] = 0
        tslAudioContext['autoplay'] = false
        tslAudioContext['loop'] = false
        tslAudioContext['obeyMuteSwitch'] = true
        tslAudioContext['volume'] = 1
        tslAudioContext['duration'] = 0
        tslAudioContext['currentTime'] = 0
        tslAudioContext['paused'] = true
        tslAudioContext['buffered'] = 0
        tslAudioContext['onPauseProcess'] = function(e){}
        tslAudioContext['onErrorProcess'] = function(e){}
        tslAudioContext['onPlayProcess'] = function(e){}
        tslAudioContext['onStopProcess'] = function(e){}
        tslAudioContext['onError'] = function (e) {
            tslAudioContext['onErrorProcess'] = e
        }
        tslAudioContext['onPlay'] = function (e) {
            tslAudioContext['onPlayProcess'] = e
        }
        tslAudioContext['onStop'] = function (e){
            tslAudioContext['onStopProcess'] = e
        }
        tslAudioContext['play'] = function () {
            if (tslAudioContext['src'] && tslAudioContext['src'].length > 4) {
                tslPlayer.playVoice({ filePath: tslAudioContext['src'] },function(){
                    tslAudioContext['onPlayProcess']()
                },function(e){
                    tslAudioContext['onErrorProcess'](e)
                },function(e){})
            }else{
                tslAudioContext['onErrorProcess']({errMsg:"src is undefined"})
            }
        }
        tslAudioContext['stop'] = function(){
            tslPlayer.stopVoice();
            tslAudioContext['onStopProcess']()
        }
        tslAudioContext['pause'] = function(){
            tslPlayer.pauseVoice()
            tslAudioContext['onPauseProcess']()
        }
        return tslAudioContext
    }
}
export default player;