var sql_module = weex.requireModule('tsl-db');
var dbname = "dbname";
var password ="pass1234word"

var sql = {
    execSQL: function (OBJECT) {
        sql_module.execSQL({dbname:OBJECT.dbname,password:OBJECT.password,sql:OBJECT.sql,bindArgs:OBJECT.bindArgs}, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    rawQuery: function (OBJECT) {
        sql_module.rawQuery({dbname:OBJECT.dbname,password:OBJECT.password,sql:OBJECT.sql,selectionArgs:OBJECT.selectionArgs}, OBJECT.success, OBJECT.fail, OBJECT.complete)
    },
    insert:function(OBJECT){
         /**
         * OBJECT 应包含表名和字段与其值 一次性插入不超过500条
         * {table:table,fields:[CommonClassId,DivisionId],values:[['3103',0],['3201',0]}
         */
        //"insert into dept(CommonClassId,DivisionId,HosId,Id,ParentId,SecPinYin,SectionName,SectionPhone,SectionType,Synctype,UpdateTime) select '3103',0,273,4087,0,'','病理科','',12,2,'2016-08-04 17:47:31' union select '3103',0,275,4391,0,'','病理科','',12,2,'2017-07-13 10:14:25' union select '3201',0,273,4083,0,'','放射科','',12,2,'2016-08-04 17:06:21' union select '5002',0,273,3273,0,'','妇科','',12,2,'2015-09-08 19:53:38' union select '1903',0,273,4084,0,'','妇科肿瘤科','',12,2,'2016-08-04 17:45:30' union select '0401',0,273,4082,0,'','腹部肿瘤外科','',12,2,'2016-08-04 17:00:36' union select '0307',0,275,4309,0,'','内分泌科','',12,2,'2017-04-06 16:45:37' union select '1901',0,273,4086,0,'','乳腺肿瘤内科','',12,2,'2016-08-04 17:47:03' union select '1901',0,273,4085,0,'','胸部肿瘤内科','',12,2,'2016-08-04 17:46:15' union select '0305',0,275,4354,0,'','血液内科','',12,2,'2017-05-11 17:51:41' union select '73',0,275,4096,0,'','药剂科','',12,2,'2016-08-12 16:28:33' union select '',0,275,4397,4354,'','一病区','',13,2,'2017-08-11 14:54:25'",
        if(OBJECT.table&&OBJECT.fields&&OBJECT.values){
            var sqlstr ="";
            var fieldstr = "";
            var valuestr = "";
            for (let index = 0; index < OBJECT.fields.length; index++) {
                fieldstr += ","+OBJECT.fields[index]
                
            }

            for (let j = 0; j < OBJECT.values.length; j++) {
                var valuesubstr = ""
                for (let jndex = 0; jndex < OBJECT.values[j].length; jndex++) {
                    valuesubstr += ","+OBJECT.values[j][jndex]
                }
                valuestr += "union select "+valuesubstr.substr(1) 
            }
            
            sqlstr = "insert into "+OBJECT.table+"("+fieldstr.substr(1)+") select "+valuestr.substr(12)
            sql.execSQL({dbname:OBJECT.dbname,
                         password:OBJECT.password,
                         sql:sqlstr},
                         OBJECT.success,OBJECT.fail,OBJECT.complete);
        }else{
            OBJECT.fail({"errMsg":"table or fields or values should not be null"})
            OBJECT.complete({"errMsg":"table or fields or values should not be null"})
        }
    },
    create:function(OBJECT){
        /**
         * OBJECT 应包含表名和字段与其属性
         * {table:table,fields:[Id_p integer primary key autoincrement,CommonClassId varchar(255)]}
         */
        //"create table dept(Id_p integer primary key autoincrement,CommonClassId varchar(255),DivisionId integer,HosId integer,Id integer,ParentId integer,SecPinYin varchar(255),SectionName varchar(255),SectionPhone varchar(255),SectionType integer,Synctype integer,UpdateTime varchar(255))"
        if(OBJECT.table&&OBJECT.fields){
            var sqlstr ="";
            for (let index = 0; index < OBJECT.fields.length; index++) {
                sqlstr += ","+OBJECT.fields[index]
            }
            sqlstr = "create table "+OBJECT.table+"("+sqlstr.substr(1)+")"
            sql.execSQL({dbname:OBJECT.dbname,
                         password:OBJECT.password,
                         sql:sqlstr},
                         OBJECT.success,OBJECT.fail,OBJECT.complete);
        }else{
            OBJECT.fail({"errMsg":"table or fields should not be null"})
            OBJECT.complete({"errMsg":"table or fields should not be null"})
        }
    },
    delete:function(OBJECT){
        /**
         * OBJECT 应包含表名和字段与其值
         * {table:table,selectionArgs:[{key:'CommonClassId',value:'18',compare:'='}]}
         */
        //DELETE FROM Person WHERE LastName = 'Wilson' 
        
        if(OBJECT.table){
            var sqlstr ;
            var selectstr = ""

            sqlstr = "DELETE FROM "+OBJECT.table

            if(OBJECT.selectionArgs){
                for (let index = 0; index < OBJECT.selectionArgs.length; index++) {
                    selectstr += "AND "+OBJECT.selectionArgs[index].key+" "+OBJECT.selectionArgs[index].compare+" "+OBJECT.selectionArgs[index].value
                }
                sqlstr = sqlstr + "WHERE " + selectstr.sub(3)
            }
            sql.execSQL({dbname:OBJECT.dbname,
                password:OBJECT.password,
                sql:sqlstr},
                OBJECT.success,OBJECT.fail,OBJECT.complete);
        }else{
            OBJECT.fail({"errMsg":"table should not be null"})
            OBJECT.complete({"errMsg":"table should not be null"})
        }
    },
    update:function(OBJECT){
        /**
         * OBJECT 应包含表名和字段与其值
         * {table:table,set:[{key:'key',value:'value'}],selectionArgs:[{key:'CommonClassId',value:'18',compare:'='}]}
         */
        //UPDATE Person SET FirstName = 'Fred' WHERE LastName = 'Wilson' 
        var sqlstr ;
        if(OBJECT.table&&OBJECT.set){
            var selectstr = ""
            var setstr = ""

            sqlstr = "UPDATE "+OBJECT.table 

            for (let index = 0; index < OBJECT.set.length; index++) {
                setstr += ", "+OBJECT.set[index].key+" = "+OBJECT.set[index].value+" "
            }
            sqlstr = sqlstr + " SET " +setstr.substr(1)

            if(OBJECT.selectionArgs){
                for (let index = 0; index < OBJECT.selectionArgs.length; index++) {
                    selectstr += "AND "+OBJECT.selectionArgs[index].key+" "+OBJECT.selectionArgs[index].compare+" "+OBJECT.selectionArgs[index].value
                }
                sqlstr = sqlstr + "WHERE " + selectstr.sub(3)
            }
            sql.execSQL({dbname:OBJECT.dbname,
                password:OBJECT.password,
                sql:sqlstr},
                OBJECT.success,OBJECT.fail,OBJECT.complete);
        }else{
            OBJECT.fail({"errMsg":"table set should not be null"})
            OBJECT.complete({"errMsg":"table set should not be null"})
        }
    },
    retrieve:function(OBJECT){
         /**
         * OBJECT 应包含表名和字段和一些条件
         * {table:table,fields:[Id_p ,CommonClassId],selectionArgs:[{key:'CommonClassId',value:'18',compare:'='}],DISTINCT:true,ORDERBY:[]}
         */
        //"with t as(SELECT * FROM dept) select * from t"
        var sqlstr = "";
        if(OBJECT.table){
            var fieldstr = ""
            var selectstr = ""
            var DISTINCTstr = ""
            var ORDERBYstr = ""

            if(OBJECT.fields){
                for (let index = 0; index < OBJECT.fields.length; index++) {
                    fieldstr += ","+OBJECT.fields[index]
                }
                fieldstr = fieldstr.substr(1)
            }else{
                fieldstr = "*"
            }

            if(OBJECT.DISTINCT){
                DISTINCTstr = "DISTINCT"
            }

            sqlstr = "SELECT "+DISTINCTstr+" "+fieldstr+" FROM "+OBJECT.table 

            if(OBJECT.selectionArgs){
                for (let index = 0; index < OBJECT.selectionArgs.length; index++) {
                    selectstr += "AND "+OBJECT.selectionArgs[index].key+" "+OBJECT.selectionArgs[index].compare+" "+OBJECT.selectionArgs[index].value
                }
                sqlstr = sqlstr + "WHERE " + selectstr.sub(3)
            }

            if(OBJECT.ORDERBY){
                ORDERBYstr = JSON.stringify(OBJECT.ORDERBY).substr(1).substring(-1,0)
                sqlstr = sqlstr + "order by "+ ORDERBYstr
            }

            sql.rawQuery({dbname:OBJECT.dbname,
                password:OBJECT.password,
                sql:sqlstr},
                OBJECT.success,OBJECT.fail,OBJECT.complete);
        }else{
            OBJECT.fail({"errMsg":"table should not be null"})
            OBJECT.complete({"errMsg":"table should not be null"})
        }
        
    }
};
export default sql;